=== debian/control ===
Source: ros-melodic-foxglove-bridge
Section: misc
Priority: optional
Maintainer: John Hurliman <john@foxglove.dev>
Build-Depends: debhelper (>= 9.0.0), libasio-dev, libgtest-dev <!nocheck>, libssl-dev, libwebsocketpp-dev, nlohmann-json-dev, ros-melodic-catkin, ros-melodic-nodelet, ros-melodic-ros-babel-fish, ros-melodic-ros-environment, ros-melodic-roscpp, ros-melodic-rosgraph-msgs, ros-melodic-roslib, ros-melodic-rostest <!nocheck>, ros-melodic-rosunit <!nocheck>, ros-melodic-std-msgs <!nocheck>, ros-melodic-std-srvs <!nocheck>, zlib1g-dev
Homepage: https://github.com/foxglove/ros-foxglove-bridge
Standards-Version: 3.9.2

Package: ros-melodic-foxglove-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openssl, ros-melodic-nodelet, ros-melodic-ros-babel-fish, ros-melodic-roscpp, ros-melodic-rosgraph-msgs, ros-melodic-roslib, zlib1g-dev
Description: ROS Foxglove Bridge
